注册 登录  
 加关注
   显示下一条  |  关闭
温馨提示!由于新浪微博认证机制调整,您的新浪微博帐号绑定已过期,请重新绑定!立即重新绑定新浪微博》  |  关闭

饥民2011

一直在搬砖

 
 
 

日志

 
 
 
 

解决Fedora 自己编译的内核不能运行Virtualbox的问题。  

2013-03-10 01:00:52|  分类: Fedora||opensuse |  标签: |举报 |字号 订阅

  下载LOFTER 我的照片书  |
         Fedora作为linux发行版的地沟油...有时候是比较坑爹的。

         Fedora有1个很出名特点,就是更新很快很激进, 本来这个是优点啦, 但是它连内核也更新的超快, 基本上2周更新一次内核, 后果就是你要不断清理就内核.. 这个还是小事。

         用过virtualbox的都知道, virtualbox是1个虚拟机软件, 它不必须根据当前的内核版本紧密配合, 对应的产物就是virtualbox模块。   virtualbox的模块有很多个, 例如最重要的vboxdrv, 还有vboxnetadp  vboxnetflt 等等, fedora 为这些模块做成了1个包,就叫kmod-Virtualbox,  如果安装这个包, 就相当于安装完virtualbox的所有模块了。

        听上去挺方便啊, 问题就是1套模组只能对应源里的1个内核, 也就是说你用yum update 让fedora帮你更新内核之后, 原来的kmod模组就不能用了, 所以virtualbox就不能打开虚拟机了。就会弹出1个提示, 让你用root权限执行1条语句修复:
/etc/sysconfig/modules/VirtualBox.modules

         这条语句实际上是让virtualbox重新匹配正确的kmod模组, 但是问题是当前系统的kmod系统版本已经跟不上更新后的内核版本了啊, 所以执行这条语句只会返回一条找不到对应模组的提示。

         正确方法是先安装对应内版本的kmod模组,  怎么安装? uname -r 查看当前内核的版本, 然后用yum search kmod-virtualbox 搜索源里的对应版本。找到后就安装它。 然后再执行上面的命令。这就修复了。

        
解决Fedora 自己编译的内核不能运行Virtualbox的问题。 - 饥民 - 饥民2011
 
             如上图。 有很多个版本的kmod啊, 分别对应每1个版本的内核。 修复后个人建议你把旧内核和旧kmod模组都卸载了。节省空间。 至于为什么fedora更新内核的时候不自动帮用户更新kmod呢。。。你以为地沟油白叫的啊...

         好了, 如果用户每更新一次内核顺手更新一次kmod就应该ok了吧?  是的, 但是由于fedora内核更新实在太快, 快到至于源里的kmod版本跟不上。。。所有很多时候更新内核的前两天就不能用virtualbox了..

        更大的问题来了, 如果有人手贱自己编译内核, 例如我....   那么这个自编译内核版本是不同于源里任1个内核的, 也就是说源里没有对应你自己编译内核的kmod模组。

        那么是不是代表自编译内核的virtualbox没法用了。

        我在网上google.  发现ubuntu的方法挺简单的, 也提供了几个很好用的工具。
        具体参靠这里:http://linux.chinarcz.com/kernel/32420.htm

        其实解决方法只有1个, 就是在当前的内核下自己编译安装kmod模组...

        Ubuntu提供的module-assistant工具很强大, 它能帮你准备编译环境, 编译成deb安装包, 有了deb包后安装和卸载都很容易了。

        问题是fedora没有这个工具。。。。。


       好吧, 虽然没i有工具, 但是源里是一样的, 下面就人手一步步来啦:

================================================================================================

       第一步,就是获取kmod的源代码, 源里一找,居然马上找到了,
解决Fedora 自己编译的内核不能运行Virtualbox的问题。 - 饥民 - 饥民2011

      这里强烈建议不要用别的地方的源代码, 因为源里的kmod代码版本是跟源里的virtualbox一致的(地沟油不抽的话)...

     第二步就是安装了:
       yum install VirtualBox-kmodsrc

   然后去/usr/src/ 里一找, 居然没有,,  尼玛装到哪里去了... 安装时完全没提示啊
   在/ 里用find . -name "*kmodsrc*" 也找不到, 说明它安装时换名字了。。 
   去google一搜, 居然没有这个源代码的使用信息...  太坑了吧~

    只好卸载它, 然后随便在1个地方新建1个文件, 例如~/test.txt
    然后再安装一次
    用find / -newer ~/test.txt 来找。。找到了 他在:
  
     /usr/share/VirtualBox-kmod-4.2.8/VirtualBox-kmod-4.2.8.tar.xz    这里,  尼玛位置太奇葩了吧~

    第三步: copy 出来解压
     随便copy到1个地方, /home里更好, 解压后得到源文件
解决Fedora 自己编译的内核不能运行Virtualbox的问题。 - 饥民 - 饥民2011

见到里面有8个文件夹, 分别对应个模块的源代码..

   第四步: 确认你的系统缺少什么模块:
再执行一次
 /etc/sysconfig/modules/VirtualBox.modules

见到提示:
[root@TFPC vboxdrv]# /etc/sysconfig/modules/VirtualBox.modules
modinfo: ERROR: Module vboxdrv not found.
modinfo: ERROR: Module vboxnetflt not found.
modinfo: ERROR: Module vboxnetadp not found.

所以实际上就只需要编译vboxdrv vobxnetflt vboxnetadp 呢3个模块就ok了。

第五步: 编译安装
进入 vboxdrv,  ls一下见到Makefile了,
执行:
make
好快就编译完,
然后:
sudo make install   (这个一步会将编译出的模块放到/lib/modules/内核版本/  下面)

如法炮制对付另外两个模块,

安装完3个模块后, 执行
 /etc/sysconfig/modules/VirtualBox.modules
这次没有错误信息, 重新打开virtualbox, 虚拟机能打开了!


第六步: 如何卸载?
我查看Makefile, 其实没有卸载这个选项的, 其实也无需卸载,
因为这3个模块只会被你这个当前版本的内核使用,

你下次再编译一次内核,那么所有的模块都会在
/lib/modules/新内核版本/  中
再编译一次kmod的模块到这个folder下就ok了

只有原来的/lib/modules/旧内核版本/   你完全可以把它们和旧内核一齐干掉。

  评论这张
 
阅读(205)| 评论(0)
推荐 转载

历史上的今天

在LOFTER的更多文章

评论

<#--最新日志,群博日志--> <#--推荐日志--> <#--引用记录--> <#--博主推荐--> <#--随机阅读--> <#--首页推荐--> <#--历史上的今天--> <#--被推荐日志--> <#--上一篇,下一篇--> <#-- 热度 --> <#-- 网易新闻广告 --> <#--右边模块结构--> <#--评论模块结构--> <#--引用模块结构--> <#--博主发起的投票-->
 
 
 
 
 
 
 
 
 
 
 
 
 
 

页脚

网易公司版权所有 ©1997-2017